from scipytools import *
#from html2text import html2text
from math import log
import os,re
from numpy import shape
from fileaccess import *
from tb.fileaccess import save_in_shelve

def extract_words(text):
    return re.findall('[a-z]+', text.lower())

def is_positive(file_name):
    if file_name.startswith(path_to_positives):
        return True
    elif file_name.startswith(path_to_negatives):
        return False
    else:
        assert 0
        

def classificator_by_path(criteria_dict):
    
    def out(path):
        for key in criteria_dict.keys():
            if key in path:
                return criteria_dict[key]
            
    return out
    
    

def build_documents(file_names, preprocessing=lambda text: text ):
    documents = []
    labels    = []
    for file_name in file_names:
        try:        
            raw_text = open(file_name, 'r').read()
            text  = preprocessing(raw_text)
            words = extract_words(text)
            if len(words) > 0: 
                documents.append(words)
                if is_positive(file_name):
                    labels.append(1)
                else:
                    labels.append(-1)
        except Exception,e:
            print "Could not apply html2text to " + file_name + ":"
            print e
            
    return documents, labels

def get_terms(documents):
    term_set  = set()
    for document in documents:
        term_set = term_set.union(set(document))

    return list(term_set)

def TF(documents, terms):
    TF = []
    for i in range(len(documents)):
        TF.append([])
        document = documents[i]
        n_words = len(document)
        #print i , n_words
        for j in range(len(terms)):        
            TF[i].append( documents[i].count(terms[j]) )
    
    return TF
    #return normalize_matrix_rows(TF)


def IDF(TF):
    n_documents, n_terms  = shape(TF)
    DF_absolut  = sum(TF > 0, 0)
    return  map(lambda x: log( ( 1.0 * n_documents ) / (x + 1) ), DF_absolut )





if 0:

            
    def get_file_names(path):
        return [ path+name for name in os.listdir(path) ]
    
    path_to_positives = "fulltext/course/"
    path_to_negatives = "fulltext/non-course/"
    
    file_names_neg = None#riffle( get_file_names(path_to_negatives) )
    file_names_pos = None#riffle( get_file_names(path_to_positives) )
    
    file_names_training_neg = file_names_neg[: (len(file_names_neg)/2)]
    file_names_test_neg  = file_names_neg[len(file_names_neg)/2:]
    
    file_names_training_pos = file_names_pos[:len(file_names_pos)/2]
    file_names_test_pos  = file_names_pos[len(file_names_pos)/2 :]
    
    
    ### part 2 do it 
    
    debug = 0
    
    file_names_training = file_names_training_neg + file_names_training_pos
    file_names_test     = file_names_test_neg + file_names_test_pos
    ## for testing
    if debug: 
        file_names_training = file_names_training[:10]
        file_names_test     = file_names_test[:14]
        
        
    documents_training, labels_training = build_documents(file_names_training)
    documents_test, labels_test         = build_documents(file_names_test)
    
    
    
    
    n_training = len(documents_training)
    n_test     = len(documents_test)
    
    terms = get_terms(documents_training)
    
    
    TF_training     =  TF(documents_training, terms)
    TF_test         =  TF(documents_test, terms)
    
    IDF_vector      =  IDF(TF_training)
    
    
    #TF_IDF_training = TF_training * repeat_row(IDF_vector, n_training )
    #TF_IDF_test     = TF_test     * repeat_row(IDF_vector, n_test )
        
    #sparse_training = sparse_rows(TF_IDF_training)
    #sparse_test     = sparse_rows(TF_IDF_test)
    
    
    save_in_shelve(terms, "terms.pyd")
    save_in_shelve(IDF_vector, "IDF.pyd")
    
    #save_in_shelve(sparse_training, "TF_IDF_training.pyd")
    #save_in_shelve(sparse_test, "TF_IDF_test.pyd")
    
    save_in_shelve(labels_training, "labels_training.pyd")
    save_in_shelve(labels_test, "labels_test.pyd")
    
    


