from numpy import sum, nan,array
from tb.baseclass  import Named, Object
from tb.scipytools import col, indices_equal
from tb.mixedtools import I

class Accuracy(Named):
    
    def apply(self, Y, Y_ ):
        values  = set(list(Y.ravel()))
        #print "YYY", Y_
        values_ = set(list(list(Y_.ravel())))

        assert len(values) <= 2 and len(values_) <= 2 
        assert len(Y) == len(Y_)
        
        return  1. * sum( col(Y) == col(Y_) ) / len(Y.ravel()) 


class WeightedAccuracy(Named):
    
    def apply(self, Y, Y_ ):
        values  = set(list(Y))
        #print "YYY", Y_
        values_ = set(list(Y_))

        assert len(values) <= 2 and len(values_) <= 2 
        assert len(Y) == len(Y_)
        
        
        
        
        return 1. * sum( Y == Y_ ) / len(Y) 



def er(Y,Y_):
    Y = array(Y)
    Y_ = array(Y_)
    
    assert len(Y) == len(Y_)
    return 1. -  1.* sum(  Y == Y_ ) / len(Y_)  


def make_stats(U, Y, Y_hat, sign):
    
    st =  Object()
        
    OO        = I(U)
    NO        = indices_equal( Y,     -sign )
    ON        = indices_equal( Y_hat, -1 )        
    OP        = indices_equal( Y_hat, +1 )    
    NP        = set(NO).intersection(set(OP))
    
    RNO       = indices_equal( Y, -1 ) # real NO
    RPO       = indices_equal( Y, +1 ) # real PO
    
    
    st.oo     = 1. * len(OO)
    st.on     = 1. * len(ON)
    st.op     = 1. * len(OP)
    st.no     = 1. * len(NO)
    st.po     = st.oo - st.no
    
    st.np     = 1. * len(NP)
    st.nn     = st.no - st.np
    st.pn     = st.on - st.nn
    
    st.rno    = 1. * len(RNO)
    st.rpo    = 1. * len(RPO)
    st.np_fraction   =  st.rno/(st.rno + st.rpo) if (st.rno + st.rpo) else nan    
    
    st.error  = (st.np + st.pn)/st.oo if st.oo else nan
    
    return st
        