import sys, re, time, datetime, inspect, os
from subprocess import Popen, PIPE


### used by peewit

def stems_from(an_object, a_class):
    """Wether the class of an_object is a_class or inherits from a_class.""" 
    
    bases = list(type(an_object).__mro__)
    bases.append(type(an_object))
    bases_   = [ ( c.__module__, c.__name__) for c in bases ]
    a_class_ = (a_class.__module__, a_class.__name__)
    
    return a_class_ in bases_


def transpose_list(rows):
    """Test wether the nested list rows has matrix form 
    and if so the columns becomes rows and vis versa."""
    
    # test wether it is a matrix
    n_rows    = len(rows)
    if n_rows == 0:
        return []
    else:
        n_columns = len(rows[0])
    
    for row in rows:
        if len(row) != n_columns: 
            print 'row lenghtes do not match.'
            return 1
    
    # get columns 
    columns = []
    for j in range(0,n_columns):
        columns.append([])
        for row in rows:
            columns[j].append(row[j])
   
    return columns



def has_unique_value(A):
    """checks wether all entries in list A are equal"""   

    if len(A) == 0:
        return True
    else: 
        a = A[0]
        return all ( [x == a for x in A] ) 


def non_equal_elements(A):
    """Tests wether all elements of A are different w.r.t. to '=='"""
    as_list = list(A)
    
    n       = len(as_list)
    
    for i in range(n):
        for j in range(i+1,n):
            if as_list[i] == as_list[j]:
                return False
    
    return True        
 


def get_line_arg(number, default=None):
    
    try:
        out = sys.argv[number]
    except:
        out =  default
    return out

    


def list_successor(liste, entry):
    """Returns entry in the next position after the first posistion of entry.
    If entries are unique, this is the next value."""
    try:
        return liste[liste.index(entry) + 1]    
    except IndexError:
        return None
        
                



def l_join( *parts):
    sep = '_'
    basename = ''
    for part in parts[:-1]:
        basename += str(part).lower() + sep
    basename += str(parts[-1]).lower()
    
    return basename

def m_join( *parts):
    sep = '-'
    basename = ''
    for part in parts[:-1]:
        basename += str(part).lower() + sep
    basename += str(parts[-1]).lower()
    
    return basename

def mm_join( *parts):
    sep = '--'
    basename = ''
    for part in parts[:-1]:
        basename += str(part).lower() + sep
    basename += str(parts[-1]).lower()
    
    return basename


def I(indexable):
    return range(len(indexable))

def indexed(indexable):
    i = 0
    for a in indexable:
        yield (i,a)
        i = i + 1

def multi_range( sizes):
    
    def rec(sizes):
        out = []
        for i in range(sizes[0]):
            if len(sizes)>1:
                for R in rec(sizes[1:]):
                    out +=  [ [i] + R ]
                    
            else:
                out += [ [i] ]
        return out
    
    sizes = list(sizes)
    return rec(sizes)
        

def peel(container):
    """Peel outermost brackets away.""" 
    if type(container) in [list, tuple] and len(container) == 1:
        return peel(container[0])
    else:
        return container
        

def shell(command_fields):
    """call a single command command_fields[0] with args
    command_fields[1:]. Cares for quotation, and escapes.
    """
    
    p = Popen( command_fields , shell=False, stdout=PIPE, stderr=PIPE )
    
    stdout_content,  stderr_content = p.communicate()
    
    if stderr_content:
        out = stdout_content + '\n' +  stderr_content
    else:
        out = stdout_content 
    
    return out


### end used by peewit



      
def tok(stage=''):
    
    c_new =  time.clock()
    
    if tok.__dict__.has_key('c'):
        seconds = c_new - tok.c
    else:
        seconds = c_new

    if not tok.__dict__.has_key('show_time'):
        tok.show_time = True
        
    stage_part = stage and ', stage ' + str(stage) or ''

    if tok.show_time:
        out  =  'Elapsed time%s: %s' % (stage_part, str(seconds))
    tok.c = c_new 
    return out


def timestamp():
    date_time_raw = str(datetime.datetime.now())
    date_time     = re.sub(r'[:\.\ -]','_', date_time_raw )
    return date_time

def timestemp2():
    return ':'.join( [ '%02d' % x  for x in time.localtime()[:6] ] ) 

def seconds2time(delta):
    """@param delta: float of seconds
    
    Return string representation of delta of form ..h ..m ..s ..ms
    """ 
    pass

    timetuple  = time.localtime(delta)

    ours    = int(delta // 3600)    
    seconds = timetuple[5]
    minutes = timetuple[4]
    milliseconds = int( ( delta * 1000 ) % 1000 )   
    
    out = str(milliseconds) + 'ms'
    
    if seconds:
        out = str(seconds) + 's ' + out
    if minutes:
        out = str(minutes) + 'm ' + out
    if ours:
        out = str(ours) + 'h ' + out
        
    return out


def flatten_list(nested_list):
    """Makes a list out of a nested list"""
    out = []
    for a_list in nested_list:
        out.extend(list(a_list))
    return out


        
def finite_state_transducer(delta):
    """delta is a list of rules that have the form
    ((state,symbol),(state[,symbol])
    The start state is the pre-state of delta[0]   
    """
    
    start_state = delta[0][0][0]
    def out(a_string):
        sequence = list(a_string)
        
        state = start_state
        for i in  range(len(sequence)):
            for (pre,post) in delta:
                if not type(post) == tuple:
                    post = [post]
                if state == pre[0] and sequence[i] == pre[1]:
                    state = post[0]
                    if len(post) == 2:
                        sequence[i] = post[1]
                    break
            
        return "".join(sequence)
    return out
  
def reverse(string):
    return string[::-1]


def module_name(full=False):
    """Return caller module name"""
    parent_frame  = inspect.stack()[1][0]
    path          = parent_frame.f_code.co_filename
    base          = os.path.basename(path)
    module_name   = os.path.splitext(base)[0]
    if full:
        return path
    else:
        return str(module_name)



if __name__ == '__main__':
    
    
    if 0:
        A = [3,4,5,34,23,]
        B = ['dd','sdfsdf', 'sdfsa', 4, 5, 4, ]
        print non_equal_elements(A)
        print non_equal_elements(B)
        
    
    
    if 0:
        A = [('d',3), ('fsdf',3), (33,2)]
        print indexed(A)
        for (i,(e,r)) in indexed(A):
            print i
            print e,r
            print
            
        #t = V(1,2)
        #d = D(31,r=44,u=4532)
         
    if 0:  
        
        delta =   (
            (('outside', '['), ('opening')),
            (('opening', '['), ('inside' )),
            (('inside',  ']'), ('closing')),
            (('closing', ']'), ('outside')),
            (('inside',  '<'), ('inside','((')),
            (('inside',  '>'), ('inside','))' ))
            )
        T = finite_state_transducer(delta)
            
                
      
        
        print T('dasd[[dff<aada>adasdad<sdad>asdd]]dasg44..<joj>jojo')
        
                        
    
