



from scipy import array, nan, shape, dot   ,inf, random                                                                                                                                                                
from tb.scipytools import trim,append_value, vlen, a2sign, indices_equal, lunion, shapes,\
				       partition_index
from tb.plotting import DataPlot
import pylab

def plot(tray):

	X,Y = tray.get_XY()
	
	dp = DataPlot(
				 show_grid	 = True,
				 data_matrix   = X,
				 output_vector = Y, 
				 #title		 = "candidate %d, value = %+f" %(i,v),
				 #lines		 = lines[i], 
				 #line_colors   = ['b'],
				 #line_text	 = [str(a) for a in I(lines[i])],
					 )
	dp.go()	   



def differences(subset_chain):
	"""which elements are in subset i but not in subset i-1?"""
	out = [ subset_chain[0] ]
	for i in I(subset_chain)[1:]:
		out += [ list(set(subset_chain[i]).difference(set(subset_chain[i-1]))) ]
	return out

def strind(s):
	if s == None:
		return ""
	else:
		return str(s)
	

def predict(umodel,X):
	w,b    = umodel
	G      = dot(X,col(w))
	F      = G - b
	Y_hat  = a2sign(F)
	return Y_hat, F

def covered(umodel, X):
        
    Y_hat, F   = predict(umodel, X)
    return indices_equal(Y_hat, +1 ) 
        
 
def OSE(X, Y, p):
    
    X_    = X
    sign  = Y[p,0]
    Y_    = sign * Y
    
    relevants  = lunion(indices_equal(Y_, -1), [p]) 
    pmodels    = [] 
    change     = True
    
    while change:
    	umodel   = engine.train(X_[ relevants ], Y_[ relevants ])
        
        pmodels += [ ( umodel, sign, p, relevants ) ]
        
        #update wroking set and detect fixpoint
        covered_indices = covered( umodel, X)
        relevants_      = lunion(relevants, covered_indices)
        change          = not set(relevants) == set(relevants_)
        relevants       = sorted(relevants_)
       

    return pmodels
   
   
def val(umodel, sign , X, Y ):
    
    (w,b)    = umodel
    Y_hat, F = predict(umodel, X)
    
    H  = vlen(w)
    F_ = F / H
    print shapes(sign,Y,F_, F)
    V  = sign * Y * col(F_)
    
    return min(V)


def one_rsmi_iteration(X,Y,k=4):

	P = list(random.permutation(len(X)))
	candidates_values = []  
	while len(candidates_values) < k:
		p                       = P.pop()
		c                       = OSE(X, Y, p)
		umodel,sign,p,relevants = c[-1]
		v                       = val( umodel, sign, X[relevants], Y[relevants] )  
		candidates_values      += [ (c,v) ]
	
	return candidates_values
 
def plots(candidates_values): 
            winner      = get_maximizer(candidates, value_index=3)
            smodel_star = winner[0]
            



if 0:
	
	D = Toy_2()
	D.build_base_set()
	
	X,Y = D.get_XY()
	print X
	print Y
	
	engine = LibSVM_wb(  kernel_type = 'linear',
	                     C           = 10,
	                  )
	
	
	C     = one_rsmi_iteration(X,Y,k=4)
	
	lines = [ [] for i in I(C) ]
	R     = [ [] for i in I(C) ]
	
	for i in I(C):
		print 
		print
		print "Candidate %d:"  % i
		c,v = C[i]
		for j in I(c):
			print 
			print "pre model %d:" % j
			(w,b), sign, p,relevants = c[j]
			R[i]     += [ relevants ]
			lines[i] += [ (w,b) ]
			print "w:           ", w.ravel()
			print "b:           ", b
			print "sign:        ", sign
			print "Working set: ", relevants
		
		print R[i]
		Q = differences(R[i])
		
		T = [ strind(partition_index(k,Q)) for k in I(X) ]
		for u in I(X):
			if Y[u] != Y[p]:
				T[u] = ""
		
		#print "RTT", T
		
			
		dp = DataPlot(
					 show_grid     = True,
					 data_matrix   = X,
					 data_text     = T, 
					 output_vector = Y, 
					 title         = "candidate %d, value = %+f" %(i,v),
					 lines         = lines[i], 
					 line_colors   = ['b'],
					 line_text     = [str(a) for a in I(lines[i])],
						 )
		dp.go()
		
		print
		print "Start point: ", p, X[p]
		print "Value:       ", v
		

import ml.data

data_factory= ml.data.RandomData2D()	
data_factory.build_data()
tray = ml.data.DataTray( data_factory = data_factory )
        
tray.build_XY( 
                      #scaling_ground_set=sample[0] 
                      )
X =  tray.get_X()
Y =  tray.get_Y()
         

dp = DataPlot(
					 show_grid     = True,
					 data_matrix   = X,
					 #data_text     = T, 
					 output_vector = Y, 
					 #title         = "candidate %d, value = %+f" %(i,v),
					 #lines         = lines[i], 
					 #line_colors   = ['b'],
					 #line_text     = [str(a) for a in I(lines[i])],
						 )
dp.go()

pylab.show()










	
