
from peewit.core import Experiment
#from peewit.presentation import Viewer 

from project_conf import PK, AR, LC


from enodes_sggo import *

from enodes_main import  data_tray, kernel_tray, sample, data_source,\
                         kernel, sigma_sequence, seed, c


etree = [   
              data_source( ts=[5], build=1 ),
              seed(),
              sample( ts=[1]), 
              data_tray(),
              kernel( ts=[1] ),
              kernel_tray(),
              
              cut_objective(ts=[0]),
                 
              sigma_sequence(),      #S
              cut_engine(),          #S
              mm_sym(ts=[0]),
              selection_criterion(ts=[0]),
              
              [ [ cuts_fan(r=8),
                  cuts(drop=1),    # [single]
               
                  sign_cand(ts=[]),       #[-1,+1]
                  c_cand(ts=[1]),      
                  c_cand_plus(ts=[0]),
                  tries(ts=[0]),
                   
                  candidate(drop=1),
                  
                  c(ts=[]),
                  sub_sample(ts=[]),
                  eval_sym(), 
                ],
                 
                [ model_plain(),
                  c( ts=[0]),
                  sub_sample( input_refs= [ ['candidate', 'model_plain']] ),
                  eval_sym(),# input_refs = [ ['c_reg_sym', 'c_reg_sym']   ]), 
                ], 

                [ model_small(),
                  c( ts=[3,4]),
                  sub_sample( input_refs=[ ['candidate', 'model_small']] ),
                  eval_sym(),#input_refs = [ ['c_reg_sym', 'c_reg_sym'] ]), 
                ], 
                [  
                  eval_global(),  
                ],                  
              ]
        ]
 


if __name__ == '__main__':
    

    EP = Experiment(pathkeeper  = PK,
                    launcher    = LC,   
                    archivist   = AR,  
                    verbose_descent = ['eval_global', 
                                       #'candidate'
                                      ],
                    version               = '1',    
                    remove_current_files  = 0, 
                    test_run              = 0,
                   )
    
    LC.specify_launch(dont                = 0,
                      dismiss             = 0,
                      target   = 'eval_global',
                      shuffeled_launch    = 0,
                      axes     = [ #('data_source', 8), 
                                   ('sample', 8), 
                                   ('kernel', 3),
                                   #('selection_criterion',2)
                                   ],    
                     )
    
    LC.time_bound = '06:30:00'
    LC.mem_bound  = '2800mb' 
    
    #AR.restore(version='R13')
    
    EP.define(etree)

    vc = EP.run()
    vc.save()
    
    #vc.aggregations([('sample','mean')])    
 
    #vi = Viewer(vc)
    #vi.print_vcube(fixed_length=5)



 