



from numpy import linalg, dot
from tb.scipytools import parametrized_line, row
from tb.plotting import DataPlot
import pylab
from pw_toolbox.fileaccess import load_from_shelve
from tb.mixedtools import indexed


def back_transform(v_0, v_1, E12_, sigma, mu):
	if E12_ is not None:
		A_ = linalg.inv(E12_)	
		v_0 = dot(row(v_0), A_).ravel()
		v_1 = dot(row(v_1), A_).ravel()
	
	v_0  = v_0 * sigma + mu
	v_1  = v_1 * sigma
	
	v_1 = v_1 / linalg.norm(v_1) 
	
	return v_0, v_1


def plot():

	B = load_from_shelve('../stored/model_r2d.pyd')
#	print len(B.models)
	
	lines     = []
	line_text = []
		
	for i,(v, b, mu, sigma, sign, E12_) in indexed(B.models):
		
		print "cut", i
		print "normal vector, threshold:", v,b
		_v_ = linalg.norm(v, ord=2.)
		#b_p = b_0 + 1.#sign *1.#/_v_
		#b_n = b_0 - 1.#sign *1.#/_v_
		
		
		for b_offset in [ 0, 1, -1 ]:
			
			v_0, v_1     = parametrized_line(v, b+b_offset)
				
			v_0, v_1 = back_transform(v_0, v_1, E12_, sigma, mu)
			line = (v_0, v_1)
			print "b-offset, parametric:",b_offset, line
			lines += [ line ]
				
		line_text += [ i,'','' ]
	
	
	print "text:", line_text
	
	
	dp = DataPlot(
	         show_grid=False,
	         data_matrix=B.X_train,
	         output_vector=B.Y_train,
	         title         = B.source_name,
	         lines=lines,
	         line_colors=['k','g','k'] * len(lines),
	         line_text=line_text,
	         colors = ['b','r']
	         #x_lim=[-5, 10],
	         #y_lim=[-5, 10],
	        )
	
	dp.go()       
	

	pylab.show()
	
	
if 1:
	
	plot()	
	pass





	

