from peewit.core import ENode

from project_conf import *


from ml.mmm import *

from ml.evaluation import er

from tb.scipytools import indices_equal, col
from tb.baseclass import Object

from numpy import max, min,log,concatenate,zeros, nan, dot, linalg, array,sqrt,shape, random

class data_values(ENode):
    
    def descent(self, sample, data_tray, kernel, kernel_tray):
        
        A_ = sample[0]
        
        A = data_tray.remove_duplicates(A_,contradictions=True)
        Y = data_tray.get_Y(A)
        
        
        
        I_n = [A[i] for i in indices_equal(Y,-1) ]
        I_p = [A[i] for i in indices_equal(Y,+1) ]
        
        assert not set(I_p).intersection(I_n)
        dists = kernel_tray.distances(I_n,I_p)

        D    = max(dists)
        d    = min(dists)
        
        M    = Object()
        M.K  = kernel_tray.query_cross(A,A)
        M    = kernel_tray.decomposition(M)
        
        Phi  = dot(M.B, M.K).transpose()
        Phi  = M.K
        
        beta_r = col(random.rand(M.n,1))
        
        project = dot(Phi,beta_r)
        print "PPP" , min(abs(project.ravel()))
        n    = len(M.K)
        
        lengths = array([linalg.norm(phi) for phi in Phi])
        
        R   = max(lengths)
        r   = min(lengths)
        
        lb  = 2/(D*R)
        up  = 2*len(A)/(d*r)
        llb = log(lb)/log(2)
        lub = log(up)/log(2)
        
        V = Object()
        V.llb = llb
        V.lub = lub
        V.Phi =Phi
        print "NNN", n, M.q, shape(Phi)
        print "RRR", r, R, sqrt(n)
        print "LBB", llb, lub
        
        return [ V ]
        






class eval(ENode):        
    
    def descent(self, model, mm_svm, data_tray, sample, c, kernel):
        
        A, E      = sample

        #self.clock("predict")
        YA_hat, fA  = mm_svm.predict(model, A, get_scores=1)
        
        
        assert len(YA_hat)==len(A)
        YE_hat  = mm_svm.predict(model, E)#,more=1)
        #self.send_clock("predict")
        

        #RA      = kernel.get_R(A) 
        n_A = len(A) * 1.
        
        YA      = data_tray.get_Y(A)
        YE      = data_tray.get_Y(E) 
        
       
        error_rate    =  er(  YE,YE_hat ) 
        error_rate_a  = er(  YA, YA_hat ) 
        gamma         = mm_svm.get_gamma(model)
        lgamma        = log(gamma)/log(2)
        mA            =  YA * fA
        epsilon       = max(concatenate( (col(zeros((n_A,1))), col(1 - mA )),axis=1),axis=1).ravel()
        q_violators   = sum(epsilon > 0.01)/n_A
        epsilon_avg   = sum(epsilon)/(q_violators*n_A) if q_violators else nan
        
     
        
        return [ # c,
                  error_rate,
                  error_rate_a,
                  lgamma/16,
                  q_violators,
                  epsilon_avg/2
                ]
        
        
    def explicit_decent_value_names(self):
        
        return [ #'c', 
                 'error_rate',
                 'error_rate_a',
                 'lgamma/16',
                 'q_violators',
                 'epsilon_avg_v'
                ]
        

