
from peewit.core import Experiment, ENode

from project_conf import PK, AR, LC

from enodes_main import  data_tray, kernel_tray, sample, sub_sample,seed, mm_sym,\
                         kernel,  c, data_source



from numpy import sort, arange, shape, argmin, sum
from tb.scipytools import nan_mean
from package.enodes_sgo import cross_distances


class cross_distances(ENode):
    
    def init(self,k_max=3200):
        pass

    def descent(self,sample, kernel_tray):
        
        A,E  = sample
        
        D    = kernel_tray.distances(E,A)
        #D    = kernel_tray.query_cross(E,A)
        

        Ds   = sort(D,axis=1)

        
        
        Dsk  = Ds[:,:self.k_max]
        
        #print Dsk
        
        return [ Dsk ]
        

class k(ENode):
    
    def descent(self, cross_distances):
        n,m = shape(cross_distances)
        return range(1,m)

    
class distance(ENode):
    def descent(self):
        pass
        return list(arange(0.0,1.45,.02))

 
    
    
class frequency(ENode):
    
    def descent(self, cross_distances, distance):
        
        D   = cross_distances#[6:10,:] 
        #D_E = nan_mean(D[:,:k], axis=1)

        R = sum( (distance-0.02 <= D) * (D < distance)  , axis=1)/ (1. * shape(D)[1])
        
        #R = sum((D < distance)  , axis=1)/ (1. * shape(D)[1])

        
        h = nan_mean(R,axis=0) 
        
        
        return [ h ]
        
    def explicit_decent_value_names(self):
        
        return [               
                r'h',
               ]




etree = [    
              data_source( ts=[0,1], build=0 ), 
              seed(),
              sample( n_folds = 4, ts=[3]), 
              data_tray(),
              kernel( ts=[0,1,2] ),
              kernel_tray(),
              cross_distances(),
              distance(),
              frequency(),
            ]

 

if __name__ == '__main__':

    E = Experiment(pathkeeper  = PK,
                   launcher    = LC,   
                   #archivist   = AR,  
                   version     = '2',    
                   remove_current_files=0, 
                   test_run    = 1,
                   #verbose_descent=['ib_eval'],
                   )
    
    LC.specify_launch( dont     = 1,
                       dismiss  = 0,
                       target   = 'frequency',
                       axes     = [ #('data_source', 8),
                                    ('sample', 4), 
                                    #('kernel', 3),
                                  ],
                      )
    
    
    LC.time_bound = '01:30:00'
    LC.mem_bound  = '800mb' 
    
    E.define(etree)

    
    
    vc = E.run()
  
  
    vc.save()
    
    
    