
from peewit.core import Experiment

from project_conf import PK, AR, LC

from enodes_main import  data_tray, kernel_tray, sample, sub_sample,seed, mm_sym,\
                         kernel,  c, data_source

from en_svm import leafc, target_instance,ib_eval, ib_problem,n_targets


etree = [    
              data_source( ts=[3], build=1 ), 
              seed(),
              sample( n_folds = 4, ts=[3]), 
              data_tray(),
              kernel( ts=[1] ),
              kernel_tray(),
              mm_sym(),
              n_targets(n=64),
               [ [
                  target_instance(),#l=1000),
                  ib_problem(drop=1,k=16), 
                  c( ts=[]),
                  sub_sample( ts=[],
                              input_refs= [ ['sample','ib_problem']]  ),
                  leafc(),
                ] , 
                [ 
                  ib_eval(),
                ] , 
              ]
            ]

 

if __name__ == '__main__':

    E = Experiment(pathkeeper  = PK,
                   launcher    = LC,   
                   archivist   = AR,  
                   version     = '2',    
                   remove_current_files=0, 
                   test_run    = 0,
                   verbose_descent=['ib_eval'],
                   )
    
    LC.specify_launch( dont     = 0,
                       dismiss  = 0,
                       target   = 'ib_eval',
                       axes     = [ #('data_source', 8),
                                    ('sample', 4), 
                                    #('kernel', 3),
                                  ],
                      )
    
    
    LC.time_bound = '01:30:00'
    LC.mem_bound  = '800mb' 
    
    E.define(etree)

    
    
    vc = E.run()
  
  
    vc.save()
    
    
    