"""Experiments to evaluate svm based on smoothed optimization against libsvm.

In particular we want to find reasonable heutistics to prune the svd. Some pruning is needed
because the due numerical reason all eigenvalue are always non-zero even they shouldnt.

Futher, we may or may not zentralise the points in the transformed space. 


Results:
One observation is that we have to use iterative smoothing with decreasing sigma even
for plain svm optimization. 
If put s=0.00001 straight away, the results are terrible, specially for relevant Cs


5.2.2011:
how does number of subsample affect performance?
8 (v01) vs 16 (vsub16) vs 4 (vsub4) vs 32 (sub32.5)


"""

from project_conf import PK, AR, LC

from enodes_main import  data_tray, seed, sample, kernel_tray, data_source,\
                         kernel,c, mm_sym, model

from en_spb import eval, data_values

from peewit.core import Experiment

from peewit.presentation import Viewer 



etree2 = [
              data_source( ts=[] ), 
              seed(),
              sample( ts=[0]), 
              data_tray(),
              kernel( ts=[0], g=3. ),
              kernel_tray(),
              data_values(),
             
              mm_sym(ts=[]),
              c( ts=[] ),
              model(),
              eval(),
              
            ]
              


if __name__ == '__main__':

    E = Experiment(pathkeeper  = PK,
                   launcher    = LC,   
                   #archivist   = AR,  
                   version    = '4',    
                   remove_current_files=0, 
                   test_run = 1,
                   #verbose_descent=['eval'],
                   )
    
    LC.specify_launch(dont     = 1,
                      dismiss  = 0,
                      target   = 'eval',
                      axes     = [ ('sample', 8), ],
                      #axes     = [ ('cut_objective', 3), ],
                     )
    
    E.define(etree2)

    E.run()
    #vc.save()
    vc1 = E.build_vcube('eval')
    vc2 = E.build_vcube('data_values')
    #vc.aggregations([('sample','mean')])    
    
    #vc1 = vc1.aggg([('mean','sample')] )
    #vc2 = vc2.aggg([('mean','sample')] )
    vc2.save()
    
 
    
    #vc3 = VCube.bold_merge(vc1, vc2, 'leaf')
    #vc3.rename_values('leaf', {'error_rate':'E'})
    #vc3.save()
    
    vc1.save()
    
    
    vi = Viewer(vc1)
    vi.print_vcube()
    
 #   V = vc2.cube.ravel()[0]
    
 #   print V.llb, V.lub
    
    vi = Viewer(vc2)
    vi.print_vcube()
    
    #vi = Viewer(vc3)
    #vi.print_vcube()
    
