"""Experiments to evaluate svm based on smoothed optimization against libsvm.

In particular we want to find reasonable heutistics to prune the svd. Some pruning is needed
because the due numerical reason all eigenvalue are always non-zero even they shouldnt.

Futher, we may or may not zentralise the points in the transformed space. 


Results:
One observation is that we have to use iterative smoothing with decreasing sigma even
for plain svm optimization. 
If put s=0.00001 straight away, the results are terrible, specially for relevant Cs


5.2.2011:
how does number of subsample affect performance?
8 (v01) vs 16 (vsub16) vs 4 (vsub4) vs 32 (sub32.5)


"""

from project_conf import PK, AR, LC

from enodes_main import  data_tray, kernel_tray, sample, sub_sample,seed, mm_sym,\
                         kernel, kernel_parameter, c, data_source

from en_svm import leaf, tuning, leaf_final


from peewit.core import Experiment


etree2 = [    
              data_source( ts=[2,3], build=1 ), 
              seed(),
              sample( ts=[2]), 
              data_tray(),
              kernel( ts=[1] ),
              kernel_tray(),
              mm_sym(),
               [ [
                  tuning(drop=1), 
                  c( ts=[1,5,8]),
                  kernel_parameter(ts=[0]),
                  sub_sample( ts=[] ),
                  leaf(),
                ] , 
                [ 
                  leaf_final(),
                ] , 
              ]
            ]

 

if __name__ == '__main__':

    E = Experiment(pathkeeper  = PK,
                   launcher    = LC,   
                   archivist   = AR,  
                   version     = '9E',    
                   remove_current_files=0, 
                   test_run    = 0,
                   verbose_descent=['leaf_final'],
                   )
    
    LC.specify_launch(   target   = 'leaf_final',
                         axes     = [ #('data_source', 8),
                                      ('sample', 8), 
                                      #('preprocessing', 2), 
                                      #('kernel', 5),
                                      ],
                         dismiss  = 0,
                         dont     = 0,
                      )
    
    
    LC.time_bound = '01:30:00'
    LC.mem_bound  = '800mb' 
    
    E.define(etree2)

    
    
    vc = E.run()
  
  
    vc.save()
    
    
    