
from peewit.core import Experiment
#from peewit.presentation import Viewer 

from project_conf import PK, AR, LC


from enodes_sgo import *

from enodes_main import  data_tray, kernel_tray, sample, data_source,\
                         kernel, sigma_sequence, seed, c, mm_sym


etree = [   
              data_source( ts=[0,1], build=1,store=0 ),
              seed(),
              sample( ts=[1]), 
              data_tray(),
              kernel( ts=[1] ),
              kernel_tray(),
              
              cut_objective(ts=[0]),
                 
              sigma_sequence(),      #S
              cut_engine(dummy=1),          #S
              mm_sym(ts=[0]), 
              selection_criterion(ts=[0]),
              
              [ 
               
                 [ cut_one(),
                  c(ts=[],drop=1),
                  sub_sample(ts=[2,3],
                             input_refs= [ ['cut_zero','cut_one']]),
                  eval_sym(),
                  ],
               
                [ rand_sample_model(),
                  c(ts=[],drop=1),
                  sub_sample(ts=[2,5], 
                             input_refs= [ ['cut_zero','rand_sample_model']] 
                             ),
                  eval_sym(), 
                ],      
                
                [ plain_model(),
                  c(ts=[],drop=1),
                  sub_sample(ts=[2,5], 
                             input_refs= [ ['cut_zero','plain_model']] 
                             ),
                  eval_sym(), 
                ],                
                           
                [ 
                  eval_rcrs(),  
                ],                  
              ]
        ]
 
if __name__ == '__main__':
    
    EP = Experiment(pathkeeper  = PK,
                    launcher    = LC,   
                    archivist   = AR,  
                    verbose_descent = ['eval_rcrs'],
                    version               = '11f',    
                    remove_current_files  = 0, 
                    test_run              = 1,
                   )
    
    LC.specify_launch(dont                = 1,
                      dismiss             = 0   ,
                      target   = 'eval_rcrs',
                      shuffeled_launch    = 0,
                      rerun               = 0,
                      axes     = [ #('data_source', 8), 
                                   ('sample', 8), 
                                   #('kernel', 3),
                                   #('selection_criterion',2)
                                   ],    
                     )
    
    LC.time_bound = '02:30:00'
    LC.mem_bound  = '1000mb' 
    
    #AR.restore(version='R13')
    
    EP.define(etree)

    vc = EP.run()
    vc.save()
    
    #vc.aggregations([('sample','mean')])    
 
    #vi = Viewer(vc)
    #vi.print_vcube(fixed_length=5)

