
from peewit.core import Experiment
#from peewit.presentation import Viewer 

from project_conf import PK, AR, LC


from enodes_sgo import *

from enodes_main import  data_tray, kernel_tray, sample, data_source,\
                         kernel, sigma_sequence, seed, c, mm_sym


etree = [   
              data_source( ts=[0], build=0,store=0 ),
              seed(),
              sample( ts=[]), 
              data_tray(),
              kernel( ts=[1] ),
              kernel_tray(),
              
              cut_objective(ts=[0]),
                 
              sigma_sequence(),      #S
              cut_engine(dummy=1),          #S
              mm_sym(ts=[0]), 
              selection_criterion(ts=[0]),
              
              [ 
               
                 [ cut_one(),
                  c(ts=[1],drop=1),
                  sub_sample(ts=[1],
                             input_refs= [ ['cut_zero','cut_one']]),
                  eval_sym(),
                  ],
               
                [ rand_sample_model(),
                  c(ts=[1],drop=1),
                  sub_sample(ts=[1], 
                             input_refs= [ ['cut_zero','rand_sample_model']] 
                             ),
                  eval_sym(), 
                ],      
                
                [ plain_model(),
                  c(ts=[1],drop=1),
                  sub_sample(ts=[1], 
                             input_refs= [ ['cut_zero','plain_model']] 
                             ),
                  eval_sym(), 
                ],                
                           
                [
                  sub_problems(), 
                  cross_distances(k_max=32),
                  distance(),
                  reached_fraction(),  
                ],                  
              ]
        ]
 
if __name__ == '__main__':
    
    EP = Experiment(pathkeeper  = PK,
                    launcher    = LC,   
                    archivist   = AR,  
                    #verbose_descent = ['eval_rcrs'],
                    version               = '5',    
                    remove_current_files  = 0, 
                    test_run              = 1,
                   )
    
    LC.specify_launch(dont                = 1,
                      dismiss             = 0,
                      target   = 'reached_fraction',
                      shuffeled_launch    = 0,
                      axes     = [ #('data_source', 8), 
                                   ('sample', 8), 
                                   ('kernel', 3),
                                   #('selection_criterion',2)
                                   ],    
                     )
    
    LC.time_bound = '12:30:00'
    LC.mem_bound  = '2400mb' 
    
    
    EP.define(etree)

    vc_ev = EP.run()
    
    #vc_rf = EP.build_vcube('reached_fraction')
    
    vc_ev.save()
    #vc_rf.save()
    

