
from peewit.core import Experiment
#from peewit.presentation import Viewer 

from project_conf import PK, AR, LC


from enodes_sgo import *

from enodes_main import  data_tray, kernel_tray, sample, data_source,\
                         kernel, sigma_sequence, seed, c, mm_sym
         

###
###

etree = [   
              data_source( ts=[4], build=1,store=0 ),
              seed(),
              sample( tsel=[0] ,max_train_size=512), 
              data_tray(),
              kernel( ts=[1] ),
              kernel_tray(),
              
              cut_objective(ts=[0]),
                 
              sigma_sequence(),     #S
              cut_engine(),         #S
              mm_sym(ts=[0]),
              selection_criterion(ts=[0]),
              
              [ [ cut_zero(), 
                  c(ts=[3,4],drop=1),
                  sub_sample(ts=[2,3,6]),
                  eval_sym(),
                  ],
               
                [ cuts_fan(r=8),
                  cuts(drop=1),     #S
               
                  sign_cand(ts=[]),       
                  c_cand(ts=[3,6]),      
                  c_cand_plus(ts=[0,1]),
                  tries(ts=[0]),
                   
                  candidate(drop=1 ),
                  
                  c(ts=[3,4]),
                  sub_sample(ts=[2,5,6], 
                             input_refs= [ ['cut_zero','candidate']] 
                             ),
                  eval_sym(), 
                ],                 
                [  
                  eval_sequence(),  
                ],                  
              ]
        ]
 
if __name__ == '__main__':
    
    EP = Experiment(pathkeeper  = PK,
                    launcher    = LC,   
                    archivist   = AR,  
                    verbose_descent = ['eval_sequence'],    
                    version               = '10_cheat_ce',    
                    remove_current_files  = 0, 
                    test_run              = 0,
                   )
    
    
    ##
    LC.specify_launch(dont                = 0,
                      dismiss             = 0,
                      target   = 'eval_sequence',
                      shuffeled_launch    = 1,
                      axes     = [ #('data_source', 8), 
                                   ('sample', 8), 
                                   ('kernel', 3),
                                   #('selection_criterion',2)
                                   ],    
                     )
    
    LC.time_bound = '12:30:00'
    LC.mem_bound  = '800mb' 
    
    EP.define(etree)

    vc = EP.run()
    vc.save()
    
    #vc.aggregations([('sample','mean')])    
 
    #vi = Viewer(vc)
    #vi.print_vcube(fixed_length=5)

## 9: Frankfurt 18:30