


from peewit.core import ENode, Experiment
from peewit.presentation import Viewer 
from peewit.vcubes import VCube


from project_conf import PK
from svm_en import *


VCube.pathkeeper = PK


if 1:
    
    vc1  = VCube(basename='svm_et--pp32--leaf_final--main')
    vc2  = VCube(basename='svm_et--pp32b--leaf_final--main')
    vc3  = VCube(basename='svm_et--pp32c--leaf_final--main')
    vc4  = VCube(basename='svm_et--pp32d--leaf_final--main')

    vc = VCube.bold_merge(vc1, vc2,'seed')
    vc = VCube.bold_merge(vc,  vc3,'seed')
    vc = VCube.bold_merge(vc,  vc4,'seed')

    
    vc = vc.aggg([ ('sel','leaf_final','error_rate'),
                ])
    vc = vc.aggg([('mean','sample')])
    #vc2 = vc.aggg([('std','sample')])



    vc.pathkeeper.version = 'pp32seed'
    vc.save()
        
    vi = Viewer(vc)
    vi.print_vcube(fixed_length=5)
    


if 0:
    ## preprocessing for baseline
    
    vc1 = VCube(basename='etree_svm--pp4--leaf_final--main')
    vc2 = VCube(basename='etree_svm--pp5--leaf_final--main')

    vc = VCube.bold_merge(vc1, vc2,'preprocessing')
    vc.pathkeeper.version = 'pp45'
    vc.save()
    
    vc = vc.aggg([ ('sel','leaf_final','error_rate'),
                   ('del', 'preprocessing', 'ScalingPM1MD' )                   
               ])
    
    
    vc.rename_values('preprocessing',
                     {'Scaling01':'S01', 'ScalingPM1':'Spm1',  'Normalization':'N',
                      'Normalization01':'N01', 'NormalizationPM1':'Npm1', 
                      'NormalizationS':'Nstd'})
    
    vc.partially_permute_values( 'preprocessing', ['S01','Spm1','N','N01','Npm1','Nstd'])
    
    vc.partially_permute_values( 'kernel',[ 'gauss','poly2', 'poly3', 'linear',])
    vc = vc.aggg([('mean','sample')])
    vi = Viewer(vc)
    vi.latex_table_snippet2(['kernel','data_source',], )
    vi.print_with_marked_argaggregations([#('preprocessing','argmin'),
                                          ('kernel','argmin')],fixed_length=5)
    vi.latex_table_snippet2


if 0:
    
    vc16 = VCube(basename='etree_sggo--s16--eval_global--main')
    vc18 = VCube(basename='etree_sggo--s18--eval_global--main')

    vc = VCube.bold_merge(vc16, vc18,'mm_sym')
    vc.pathkeeper.version = 's1618'
    vc.save()
    
    
    vc = vc.aggg([('mean','sample')])
    vi = Viewer(vc)
    vi.print_vcube(fixed_length=5)
    

if 0:
    vc1 = VCube(basename='etree_sggo--t1--eval_global--main')

    #vc1.pathkeeper.partname = 'small_set'

    sel1 = ( 'sel', 'eval_global', 
             'error_plain','error_small','error_res','fraction_res', 'n_cuts')
    
    sel2 = ( 'del', 'eval_global', 
             'error_small', 'value_loss', 'error_small'
           )

    vc1 = vc1.aggg([('mean','sample'),
                    ('seli', 'selection_criterion',0),
                    sel2,
                    ])

    vi = Viewer(vc1)

    vi.print_vcube(fixed_length=5)

    vi.latex_table_snippet2(row_dims=['kernel','data_source'], 
                            column_dims=['eval_global'])
    
    
   
if 0:
    vc1 = VCube(basename='etree_svm--limi2--leaf--main')

    vc1 = vc1.aggg([('mean','sample')])
    #vc1 = vc1.aggg([('seli', 'sample', 2, 3)])
    
    vi = Viewer(vc1)

    vi.print_vcube(fixed_length=5)

    vi.latex_table_snippet2(row_dims=['data_source'])
    
if 0:
    
    
    PK.read_basename('etree_svm--mal--leaf--main')
    
    vc1 = VCube(pathkeeper=PK)
    
    PK.read_basename('etree_sggo--r13--eval_all--main')
    
    vc2 = VCube(pathkeeper=PK)
    
    vc1 = vc1.aggg([
              ('sel', 'kernel', 'linear', 'poly2', 'poly2'),
             ]
    )
    vc2 = vc2.aggg([
              ('sel', 'cut_objective', 'SecoObjectiveE' )
             ]
    )
    
    vc1.rename_dim('leaf', 'eval_all')
    vc1.rename_values('eval_all', {'error_rate':'baseline'})
    
    
    vc3 = VCube.bold_merge(vc2, vc1)
    
    vc3.partially_permute_values('eval_all',['baseline'])
    vc3 = vc3.aggg([('sel', 'kernel','linear',),
                    ('del', 'eval_all','n_cuts',),])
    
    
    vi = Viewer(vc3)
    vi.print_vcube(fixed_length=5)
    
    
    vc4 = vc3.aggg([('mean','sample')
                    ])
    
    vc5 = vc3.aggg([('std','sample')
                    ])
    
    vc6 = VCube.bold_merge(vc4, vc5)

    
    vi = Viewer(vc6)
    vi.print_vcube(fixed_length=5)
    
    #vi.latex_table_snippet(line_dims=['data_source', 'kernel'])
    
    #vc.partially_permute(['sample'])
    
    #vi = Viewer(vc)
    #vi.print_vcube()
    
